<?php

namespace Internetgalerie\IgDatapoolFe\Services\Exporter;

/**
 * This class provides an export
 */
class JsonExporterService extends ExporterService
{
    public function before()
    {
    }

    public function after()
    {
        header('Content-disposition: attachment; filename=' . $this -> options['filename'] . '.json');
        header('Content-type: application/json');

        $jsonEncoderOptions = 0;
        if ($this -> options['forceObject']) {
            $jsonEncoderOptions |= JSON_FORCE_OBJECT;
        }
        echo json_encode(array_values($this -> res), $jsonEncoderOptions);
    }

    public function exportLine($array, $uid)
    {
    }
}
